100 REMark =============================
105 REMark ******** SOUNDER_bas ********
110 REMark =============================
115 :
120 REMark  A tune composition program
125 REMark    Written by Peter Hale
130 REMark Requires file: SOUNDER_ext
135 REMark    Be loaded into memory
140 REMark  Read SOUNDER_doc for Info
145 :
150 REMark     LRUN SOUNDER_boot
155 :
200 REMark After initializing extensions, remove REMark in line 204/206
202 REMark to demonstrate possible key presses that will give notes.
204 REMark FOR n=15 TO 103 : TUNE CHR$(n)&"2": PRINT n!CHR$(n) : END FOR n
206 REMark FOR n=168 TO 206: TUNE CHR$(n)&"2": PRINT n!CHR$(n) : END FOR n
208 REMark by Peter R. Hale, NESQLUG,1991
212 ct$="" : prog$="SOUND MACHINE" : MODE 4 : menu
213 :
300 DEFine PROCedure compose
302 REMark -------------------
304   AT 1,8 : INPUT "Choose a speed : ";speed$ : TEMPO speed$
306   POKE 163976,255
308   INPUT\,"Choose a title : ";title$ : PRINT
310   POKE 163976,0
312   ct$=title$ : ct=LEN(ct$)
314   FOR title=1 TO ct
316    IF ct$(title) INSTR " " :  ct$=ct$(1 TO title-1)&ct$(title+1 TO) : ct=ct-1 : END IF 
318    IF NOT " " INSTR ct$ : EXIT title : END IF 
320   END FOR title
322   file$=title$&speed$ : tune$="" : note$=""
324   REPeat notes
326     IF LEN(note$) : PRINT "<ENTER> alone to return to menu or" : END IF 
328     INPUT " ENTER a note: ";note$
330     IF note$="" : EXIT notes : END IF 
332     IF LEN(note$)=3 AND note$(1)<>"#" OR LEN(note$)<2 OR LEN(note$)>3: NEXT notes : END IF 
334     IF NOT note$(LEN(note$)) INSTR '12345678' : NEXT notes : END IF 
336     IF NOT note$(LEN(note$)-1) INSTR 'ABCDEFG' : NEXT notes : END IF 
338     TUNE note$
340     PRINT "Is ";note$;" correct? (y/n) ": ans$=INKEY$(-1)
342     IF ans$=="y" OR ans$=""
344       tune$=tune$&note$ : file$=file$&note$
346       AT 4,4 : PRINT file$; : CLS 2 : PRINT
348     END IF 
350   END REPeat notes
352   parse
354 END DEFine compose
356 :
400 DEFine PROCedure fix
402 REMark ---------------
404   fix_wind
406   WINDOW 300,227,200,24 : CLS : PRINT " SPEED set at ";speed$
408   PRINT " Change Speed? (y/n) "; : ans$=INKEY$(-1) : CLS 3
410   IF ans$=="y"
412     INPUT "New SPEED ";speed$ : CLS
414     PRINT" New Tune SPEED set at ";speed$
416   END IF 
418   file$=title$&speed$&tune$ : parse : size=DIMN(tun$) : m=1 : n=1
420   REPeat loop
422     IF n<1 : n=32 : m=m-1 : END IF 
424     IF m<1 : m=1 : END IF 
426     IF n>32 : n=1 : m=m+1 : END IF 
428     IF m>size : m=size : END IF 
430     FOR grid=1 TO size
432       AT 2*grid,1 : PRINT tun$(grid)
434     END FOR grid
436     AT 1+2*m,n : PRINT "^";n
438     AT 2*m,n : fixer$=INKEY$(-1) : AT 1+2*m,n : CLS 3
440     IF fixer$>CHR$(190)
442       num=CODE(fixer$)
444       SELect ON num
446         =192 : n=n-1
448         =196 : n=n-10
450         =200 : n=n+1
452         =204 : n=n+10
454         =208 : m=m-1
456         =216 : m=m+1
458         =REMAINDER 
460       END SELect 
462       NEXT loop
464     END IF 
466     IF NOT fixer$ INSTR "12345678ABCDEFGIX #*" : NEXT loop : END IF 
468     IF fixer$=" " THEN EXIT loop
470     IF fixer$=="i" : fixer$=" "&tun$(m)(n) : END IF 
472     IF fixer$=="x" : fixer$="" : END IF 
474     IF n<=1
476       tun$(m)=fixer$&tun$(m)(2 TO)
478     ELSE 
480       tun$(m)=tun$(m)(1 TO n-1)&fixer$&tun$(m)(n+1 TO )
482     END IF 
484     REMark IF tun$(size)(LEN(tun$(size)))<>"*"
486     REMark   tun$(size)=tun$(size)&"*"
488     REMark END IF
490     n=n+(1=LEN(fixer$))
492   END REPeat loop
494   tune$=""
496   FOR grid=1 TO size
498     IF ' ' INSTR tun$(grid)
500       tun$(grid)=tun$(grid)(1 TO ' ' INSTR (tun$(grid))-1)
502     END IF 
504     tune$=tune$&tun$(grid)
506   END FOR grid
508   file$=title$&speed$&tune$
510 END DEFine fix
512 :
600 DEFine PROCedure parse
602 REMark -----------------
604   FOR tit=1 TO 40
606     IF file$(tit) INSTR "123456789"
608       title$=file$(1 TO tit-1) : EXIT tit
610     END IF 
612   END FOR tit
614   subfile$=file$(tit TO)
616   FOR spd=2 TO 5
618     IF subfile$(spd) INSTR "ABCDEFG#"
620       speed$=subfile$(1 TO spd-1) : EXIT spd
622     END IF 
624   END FOR spd
626   TEMPO speed$ : tune$=subfile$(spd TO )
628   fill_array
630 END DEFine parse
632 :
700 DEFine PROCedure fill_array
702 REMark ----------------------
704   m=INT(LEN(tune$)/32)+2 : DIM tun$(m,33)
706   tmp$=tune$
708   FOR array=1 TO m
710     IF LEN(tmp$)<=32
712       tun$(array)=tmp$
714     ELSE 
716       FOR n=32 TO 1 STEP -1
718         IF tmp$(n) INSTR "12345678"
720           tmp=n : EXIT n
722         END IF 
724       END FOR n
726       tun$(array)=tmp$(1 TO tmp)
728     END IF 
730     IF LEN(tmp$)>32
732       tmp$=tmp$(LEN(tun$(array))+1 TO)
734     ELSE 
736       tmp$=""
738     END IF 
740   END FOR array
742 END DEFine fill_array
744 :
800 DEFine PROCedure play
802 REMark ----------------
804   WINDOW 512,256,0,0 : PAPER 4 : INK 0 : BORDER 5,7 : CLS
806   CSIZE 3,1 : AT 2,12 : PRINT "PLAYING"
808   PRINT\\ TO 15-LEN(title$)/2; title$ : CSIZE 0,0
810   FOR song=1 TO DIMN(tun$)
812     REMark PRINT tun$(song)
814     TUNE tun$(song)
816   END FOR song
818 END DEFine play
820 :
900 DEFine PROCedure Multiplay
902 REMark ---------------------
904   INPUT#0, "Play how many tunes (0 to EXIT) (1 to ?) ";n_s
906   IF n_s=0 : menu : END IF 
908   DIM Song_name$(n_s,50)
910   FOR m_p= 0 TO n_s-1
912     load_tune : Song_name$(m_p)=t_file$
914   END FOR m_p
916   INPUT#0,"How many repeats of selection? (0 to ?) ";Song_name$(n_s)
918 END DEFine Multiplay
920 :
1000 DEFine PROCedure Play_selections
1002 REMark ---------------------------
1004   FOR m_p=0 TO n_s-1
1006     OPEN#3,Song_name$(m_p) : INPUT#3,file$ : CLOSE#3
1008     parse : play
1010   END FOR m_p
1012   IF Song_name$(n_s)>"0"
1014     m=Song_name$(n_s) : Song_name$(n_s)=m-1 : Play_selections
1016   END IF 
1018 END DEFine Multiplay
1020 :
1100 DEFine PROCedure sav_tune
1102 REMark --------------------
1104   PRINT#0,"Current file: ";ct$; : file_tune "save"
1106   DELETE t_file$
1108   OPEN_NEW#3,t_file$ : PRINT#3,file$ : CLOSE#3
1110 END DEFine sav_tune
1112 :
1200 DEFine PROCedure load_tune
1202 REMark ---------------------
1204   file_tune "load"
1206   OPEN#3,t_file$ : INPUT#3,file$ : CLOSE#3
1208 END DEFine load_tune
1210 :
1300 DEFine PROCedure file_tune (var$)
1302 REMark --------------------------
1304   POKE 163976,255
1306   PRINT#0,!!!"File to ";var$;" or ? for dir ";dev$; : INPUT#0;t_file$
1308   POKE 163976,0
1310   IF t_file$="?" : CLS : DIR dev$ : file_tune var$ : END IF 
1312   IF var$="save" AND t_file$="" : t_file$=ct$ : END IF 
1314   IF t_file$="" : menu : END IF 
1316   IF t_file$(1 TO 3)==dev$(1 TO 3)AND t_file$(4)<>dev$(4)
1318     dev$=dev$(1 TO 3)&t_file$(4 TO 5)
1320   END IF 
1322   IF t_file$(1 TO 5)==dev$ : t_file$=dev$&t_file$(6 TO): END IF 
1324   IF t_file$(1 TO 5)<>dev$ : t_file$=dev$&t_file$ : END IF 
1326   IF t_file$(LEN(t_file$)-4 TO)=="_TUNE"
1328     t_file$=t_file$(1 TO LEN(t_file$)-5)
1330   END IF 
1332   ct$=t_file$(6 TO LEN(t_file$)) : t_file$=dev$&ct$&"_tune"
1334 END DEFine file_tune
1336 :
1400 DEFine PROCedure fix_wind
1402 REMark --------------------
1404   OPEN#3,scr : WINDOW#3,175,256,0,0 : BORDER#3,5,2 : CLS#3
1406   PRINT#3,\"   HOW TO MODIFY A TUNE"
1408   PRINT#3,\" Use   cursor keys to"\"     move along score."
1410   PRINT#3,\" Use   cursor keys to"\"     change lines."
1412   PRINT#3,\" <SHIFT>+  or  moves 10"
1414   PRINT#3,\' Cursor is above the "^"'
1416   PRINT#3,\" Change a character by"\"     overwriting it."
1418   PRINT#3,\" Press 'x' to Delete."
1420   PRINT#3,\" Press 'i' to Insert."
1422   PRINT#3,\" Press <SPACE> to escape"\"     and play"
1424   CLOSE#3 : WINDOW 338,256,174,0 : BORDER 5,0 : CLS
1426   IF tune$(LEN(tune$))<>"*" : tune$=tune$&"*": END IF 
1428   IF tune$(LEN(tune$)-1)="*" : tune$=tune$(1 TO LEN(tune$)-1) : END IF 
1430   AT 1,3 : PRINT "Tune Title is ";title$
1432   PRINT TO 3;"Change Title? (y/n) "; : ans$=INKEY$(-1)
1434   IF ans$=="y"
1436    INPUT "New title ";title$
1438    AT 1,3 : PRINT "NEW Tune Title is ";title$
1440   END IF 
1442 END DEFine fix_wind
1444 :
1500 DEFine PROCedure menu
1502 REMark ----------------
1504   IF ct$="" : file$="" : speed$="" : tune$="" : END IF 
1506   WINDOW#0,492,22,10,229 : CSIZE 0,0 : CLS#0
1508   REPeat Menuloop
1510     WINDOW 512,256,0,0 : PAPER 4 : INK 0 : BORDER 5,7 : CLS
1512     CSIZE 3,1 : AT 0,15-LEN(prog$)/2 : PRINT prog$ : CSIZE 0,0
1514     AT 3,32 : PRINT "1 INSTRUCTIONS"
1516     PRINT \,,,,"2 COMPOSE A TUNE"
1518     PRINT \,,,,"3 LOAD A TUNE"
1520     PRINT\,,,,"4 DEMONSTRATE EXTENSIONS"
1522     IF ct$<>""
1524       PRINT\,,,,"5 SAVE "; : INK 2 : PRINT title$ : INK 0
1526       PRINT\,,,,"6 FIX THE NOTES IN "; : INK 2 : PRINT title$ : INK 0
1528       PRINT\,,,,"7 PLAY "; : INK 2 : PRINT title$ : INK 0
1530       PRINT\,,,,"8 MAKE MULTIPLE SELECTIONS"
1532     END IF 
1534     PRINT\,,,,"Q or <ESC> for Quit"
1536     PRINT \,,,"MAKE A CHOICE (alpha or numeric)";
1538     Getkey$=INKEY$(-1) : getkey=CODE(Getkey$) : CLS
1540     SELect ON getkey
1542       =49,73,105 : instructions
1544       =51,76,108 : load_tune : parse
1546       =50,67,99  : compose
1548       =52,68,100 : demo
1550       =53,83,115 : sav_tune
1552       =54,70,102 : fix
1554       =55,80,112 : play
1556       =56,77,109 : Multiplay : Play_selections
1558       =27,81,113 : STOP
1560       =REMAINDER 
1562     END SELect 
1564   END REPeat Menuloop
1566 END DEFine menu
1568 :
1600 DEFine PROCedure instructions
1602 REMark ------------------------
1604   WINDOW#1,482,200,18,30 : BORDER#1,6,2 : CLS#1
1606   PRINT\\,prog$;" lets you compose elementary tunes"
1608   PRINT,  " and play them back."
1610   PRINT\, "First select the 'SPEED' of the tune you wish to compose."
1612   PRINT,  "This can be a number from 1 up, but"
1614   PRINT,  " for practical purposes 500 is a minimum value."
1616   PRINT\, "The value of 'SPEED' is proportional"
1618   PRINT,  " to the duration of a note."
1620   PRINT\, "Thus, a given note played at SPEED 1500 will be held"
1622   PRINT,  " twice as long as the same note played at SPEED 750."
1624   INPUT\, "For starters try 1500.  Select a SPEED (numerals only) : ";speed$
1626   IF speed$="" : speed$="1500" : END IF 
1628   FOR a=1 TO LEN(speed$)
1630     IF NOT speed$(a) INSTR '0123456789' : menu
1632   END FOR a
1634   TEMPO speed$: CLS
1636   PRINT\\,"Next, you will be prompted for some notes in a tune."
1638   PRINT,  "Two octaves are available to you."
1640   PRINT\, "A note is represented by up to three characters."
1642   PRINT,  "The minimum is two."
1644   PRINT\, "The first character is normally a letter,"
1646   PRINT,, "     A to G for the lower octave"
1648   PRINT,, " and a to g for the upper octave"
1650   PRINT\, "The second character is normally a number, 1 to 8."
1652   PRINT,  "The number 1 represents an eighth note, 4 a half note, etc."
1654   PRINT\, "For a sharp, preceed the note desired by the #."
1656   PRINT,  "For a flat, preceed the note lower than the note desired by a #."
1658   PRINT\,,"Press any key to continue" : PAUSE (1500) : CLS
1660   PRINT\\,"Initially, the menu offers four choices and Quit."
1662   PRINT\, "You can get these instructions, load a tune from media,"
1664   PRINT,  "compose a tune, or play a demonstration of the extensions."
1666   PRINT\, "Once a tune is loaded, or a composition is begun,"
1668   PRINT,  "you will have three additional choices."
1670   PRINT\, "You can save the tune in memory,"
1672   PRINT,  "modify the tune, or play it."
1674   PRINT\,,"Press any key to continue" : PAUSE (1200)
1676 END DEFine instructions
1678 :
1700 DEFine PROCedure demo
1702 REMark ----------------
1704   REMark : TUNE and TEMPO demonstration program
1706 :
1708   TEMPO 1500
1710 :
1712   RESTORE 1732
1714   PRINT : PRINT
1716   REPeat play_demo
1718     READ demo_tune$
1720     IF demo_tune$="*" THEN EXIT play_demo
1722     PRINT,,,,demo_tune$
1724     TUNE demo_tune$
1726   END REPeat play_demo
1728 END DEFine demo
1730 :
1732   DATA "C1F4C1a1G1F1D7"
1734   DATA "G1G2F1E1F1E1D1C1A4"
1736   DATA "A1#A1B1"
1738   DATA "C1F4C1a1G1F1D7"
1740   DATA "G1G2F1E1C2G1F7"
1742   DATA "*"
